//---------------------------------------------------------------------------
#include <windows.h>
#include "tp_stub.h"
#include <math.h>
#include "wave.h"
#include "common.h"

//---------------------------------------------------------------------------
/*
	'g' gWV
	X^XN[ɂgWV
*/
//---------------------------------------------------------------------------
class tTVPWaveTransHandler : public iTVPDivisibleTransHandler
{
	//	'g' gWVnhNX̎

	tjs_int RefCount; // QƃJE^
		/*
			iTVPDivisibleTransHandler  QƃJE^ɂǗs
		*/

protected:
	tjs_uint64 StartTick; // gWVJn tick count
	tjs_uint64 HalfTime; // gWVɗv鎞 / 2
	tjs_uint64 Time; // gWVɗv鎞
	tTVPLayerType LayerType; // C^Cv
	tjs_int Width; // 摜̕
	tjs_int Height; // 摜̍
	tjs_int MaxH; // őU
	double MaxOmega; // őpx
	tjs_int CurH; // ݂̐U
	double CurOmega; // ݂̊px
	double CurRadStart; // pJnʒu
	tjs_int64 CurTime; // ݂ tick count
	tjs_int BlendRatio; // uh
	tjs_uint32 BGColor1; // wiF̂P
	tjs_uint32 BGColor2; // wiF̂Q
	tjs_uint32 CurBGColor; // ݂̔wiF
	tjs_int WaveType; // 0 = ŏƍŌ 1 = ŏ 2 = Ō gׂ
	bool First; // ԍŏ̌Ăяoǂ

public:
	tTVPWaveTransHandler(tjs_uint64 time, tTVPLayerType layertype,
		tjs_int width, tjs_int height,
		tjs_int maxh, double maxomega,
		tjs_uint32 bgcolor1, tjs_uint32 bgcolor2, tjs_int wavetype)
	{
		RefCount = 1;

		LayerType = layertype;
		Width = width;
		Height = height;
		Time = time;
		HalfTime = time / 2;
		MaxH = maxh;
		MaxOmega = maxomega;
		BGColor1 = bgcolor1;
		BGColor2 = bgcolor2;
		WaveType = wavetype;

		First = true;
	}

	virtual ~tTVPWaveTransHandler()
	{
	}

	tjs_error TJS_INTF_METHOD AddRef()
	{
		// iTVPBaseTransHandler  AddRef
		// QƃJE^CNg
		RefCount ++;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD Release()
	{
		// iTVPBaseTransHandler  Release
		// QƃJE^fNgA0 ɂȂȂ delete this
		if(RefCount == 1)
			delete this;
		else
			RefCount--;
		return TJS_S_OK;
	}


	tjs_error TJS_INTF_METHOD SetOption(
			/*in*/iTVPSimpleOptionProvider *options // option provider
		)
	{
		// iTVPBaseTransHandler  SetOption
		// Ƃɂ邱ƂȂ
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD StartProcess(tjs_uint64 tick);

	tjs_error TJS_INTF_METHOD EndProcess();

	tjs_error TJS_INTF_METHOD Process(
			tTVPDivisibleData *data);

	tjs_error TJS_INTF_METHOD MakeFinalImage(
			iTVPScanLineProvider ** dest,
			iTVPScanLineProvider * src1,
			iTVPScanLineProvider * src2)
	{
		*dest = src2; // ɍŏI摜 src2
		return TJS_S_OK;
	}
};
//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPWaveTransHandler::StartProcess(tjs_uint64 tick)
{
	// gWV̉ʍXV񂲂ƂɌĂ΂

	// gWV̉ʍXVɂA܂ŏ StartProcess Ă΂
	// ̂ Process Ă΂ ( ̈𕪊Ăꍇ )
	// Ō EndProcess Ă΂

	if(First)
	{
		// ŏ̎s
		First = false;
		StartTick = tick;
	}

	// 摜ZɕKvȊep[^vZ
	tjs_int64 t = CurTime = (tick - StartTick);
	if(CurTime > Time) CurTime = Time;
	if(t >= HalfTime) t = Time - t;
	if(t < 0) t = 0;

	double tt = sin((3.14159265358979/2.0) * t / (tjs_int64)HalfTime);

	// CurH, CurOmega, CurRadStart
	CurH = tt * MaxH;
	switch(WaveType)
	{
	case 0: // ŏƍŌオgׂ
		CurOmega = MaxOmega * tt;
		break;
	case 1: // ŏgׂ
		CurOmega = MaxOmega * ((tjs_int64)Time - CurTime) / (tjs_int64)Time;
		break;
	case 2: // Ōオgׂ
		CurOmega = MaxOmega * CurTime / (tjs_int64)Time;
		break;
	}
	CurRadStart = -CurOmega * (Height / 2);

	// BlendRatio
	BlendRatio = CurTime * 255 / Time;
	if(BlendRatio > 255) BlendRatio = 255;

	// wiF̃uh
	CurBGColor = Blend(BGColor1, BGColor2, BlendRatio);

	return TJS_S_TRUE;
}
//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPWaveTransHandler::EndProcess()
{
	// gWV̉ʍXV񕪂I邲ƂɌĂ΂

	if(BlendRatio == 255) return TJS_S_FALSE; // gWVI

	return TJS_S_TRUE;
}
//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPWaveTransHandler::Process(
			tTVPDivisibleData *data)
{
	// gWV̊ë悲ƂɌĂ΂
	// gg͉ʂXVƂɂ̗̈ɕȂ珈ŝ
	// ̃\bh͒ʏAʍXVɂĂ΂

	// data ɂ͗̈摜Ɋւ񂪓Ă

	// p[^vZ
	double rad = data->Top * CurOmega + CurRadStart; // px

	// CƂɏ
	tjs_int n;
	for(n = 0; n < data->Height; n++, rad += CurOmega)
	{
		// Yʒu
		tjs_int d = (tjs_int)(sin(rad) * CurH);

		// ]
		tjs_int l, r;

		// łׂƂ́Adata->Src1  data->Src2  (0, data->Top + n) 
		// n܂PC BlendRatio ɂăuhA(d, data->Top + n) 
		// ]B͂ݏoĕ`悳Ȃ CurBGColor œhԂB
		// AE data->Left  data->Width ɂăNbsOB
		// ܂Adata->Dest ɓ]Ƃ́ÃItZbg (data->Left, data->Top)
		// ł͂Ȃ(data->DestLeft, data->DestTop) ɂȂ̂ŕ␳B

		// XLC
		tjs_uint32 *dest;
		const tjs_uint32 *src1;
		const tjs_uint32 *src2;
		if(TJS_FAILED(data->Dest->GetScanLineForWrite(data->DestTop + n, (void**)&dest)))
			return TJS_E_FAIL;
		if(TJS_FAILED(data->Src1->GetScanLine(data->Top + n, (const void**)&src1)))
			return TJS_E_FAIL;
		if(TJS_FAILED(data->Src2->GetScanLine(data->Top + n, (const void**)&src2)))
			return TJS_E_FAIL;

		// ̂镔ɔwiF]
		if(d > 0)
		{
			l = 0;
			r = d;
			if(Clip(l, r, data->Left, data->Left + data->Width))
				TVPFillARGB(dest + l + data->DestLeft - data->Left, r - l, CurBGColor);
		}

		// [̂镔ɔwiF]
		if(d < 0)
		{
			l = d + Width;
			r = Width;
			if(Clip(l, r, data->Left, data->Left + data->Width))
				TVPFillARGB(dest + l + data->DestLeft - data->Left, r - l, CurBGColor);
		}

		// uhȂ]
		// TVPConstAlphaBlend_SD(dest, src1, src2, len, opa)
		//  dest  src1  src2  opa Ŏw肵ōē]
		l = d;
		r = Width + d;
		if(Clip(l, r, data->Left, data->Left + data->Width))
		{
			if(LayerType == ltAlpha)
				TVPConstAlphaBlend_SD_d(dest + l + data->DestLeft - data->Left,
					src1 + l - d, src2 + l - d, r - l, BlendRatio);
			else if(LayerType == ltAddAlpha)
				TVPConstAlphaBlend_SD_a(dest + l + data->DestLeft - data->Left,
					src1 + l - d, src2 + l - d, r - l, BlendRatio);
			else
				TVPConstAlphaBlend_SD(dest + l + data->DestLeft - data->Left,
					src1 + l - d, src2 + l - d, r - l, BlendRatio);
				/*
					]悪Ăꍇ̓uhASYႤ̂
					ӂKvB
					_d ̃TtBbNXuh֐ׂ͂Ēʏ̃uhŁA
					lluhsBl _a ̃TtBbNX
					uh֐͉ZuhłB_a  _d TtBbNX
					Ȃuh֐ɔׂĒᑬB_d  _a TtBbNX
					uh֐̓l͈Ȃ ( ɊSɕsłƈ )B
				*/
		}
	}


	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
class tTVPWaveTransHandlerProvider : public iTVPTransHandlerProvider
{
	tjs_uint RefCount; // QƃJE^
public:
	tTVPWaveTransHandlerProvider() { RefCount = 1; }
	~tTVPWaveTransHandlerProvider() {; }

	tjs_error TJS_INTF_METHOD AddRef()
	{
		// iTVPBaseTransHandler  AddRef
		// QƃJE^CNg
		RefCount ++;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD Release()
	{
		// iTVPBaseTransHandler  Release
		// QƃJE^fNgA0 ɂȂȂ delete this
		if(RefCount == 1)
			delete this;
		else
			RefCount--;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD GetName(
			/*out*/const tjs_char ** name)
	{
		// ̃gWV̖OԂ
		if(name) *name = TJS_W("wave");
		return TJS_S_OK;
	}


	tjs_error TJS_INTF_METHOD StartTransition(
			/*in*/iTVPSimpleOptionProvider *options, // option provider
			/*in*/iTVPSimpleImageProvider *imagepro, // image provider
			/*in*/tTVPLayerType layertype, // destination layer type
			/*in*/tjs_uint src1w, tjs_uint src1h, // source 1 size
			/*in*/tjs_uint src2w, tjs_uint src2h, // source 2 size
			/*out*/tTVPTransType *type, // transition type
			/*out*/tTVPTransUpdateType * updatetype, // update typwe
			/*out*/iTVPBaseTransHandler ** handler // transition handler
			)
	{
		if(type) *type = ttExchange; // transition type : exchange
		if(updatetype) *updatetype = tutDivisible;
			// update type : divisible
		if(!handler) return TJS_E_FAIL;
		if(!options) return TJS_E_FAIL;

		if(src1w != src2w || src1h != src2h)
			return TJS_E_FAIL; // src1  src2 ̃TCYvĂȂƑʖ


		// IvV𓾂
		tTJSVariant tmp;
		tjs_uint64 time;
		tjs_int maxh = 50;
		double maxomega = 0.2;
		tjs_uint32 bgcolor1 = 0;
		tjs_uint32 bgcolor2 = 0;
		tjs_int wavetype = 0;

		if(TJS_FAILED(options->GetValue(TJS_W("time"), &tmp)))
			return TJS_E_FAIL; // time w肳ĂȂ
		if(tmp.Type() == tvtVoid) return TJS_E_FAIL;
		time = (tjs_int64)tmp;
		if(time < 2) time = 2; // ܂菬Ȑlw肷Ɩ肪N̂

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("maxh"), &tmp)))
			if(tmp.Type() != tvtVoid) maxh = (tjs_int)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("maxomega"), &tmp)))
			if(tmp.Type() != tvtVoid) maxomega = (double)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("bgcolor1"), &tmp)))
			if(tmp.Type() != tvtVoid) bgcolor1 = (tjs_int)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("bgcolor2"), &tmp)))
			if(tmp.Type() != tvtVoid) bgcolor2 = (tjs_int)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("wavetype"), &tmp)))
			if(tmp.Type() != tvtVoid) wavetype = (tjs_int)tmp;


		// IuWFNg쐬
		*handler = new tTVPWaveTransHandler(time, layertype,
			src1w, src1h, maxh, maxomega,
			bgcolor1, bgcolor2, wavetype);

		return TJS_S_OK;
	}

} static * WaveTransHandlerProvider;
//---------------------------------------------------------------------------
void RegisterWaveTransHandlerProvider()
{
	// TVPAddTransHandlerProvider găgWVnhvoC_
	// o^
	WaveTransHandlerProvider = new tTVPWaveTransHandlerProvider();
	TVPAddTransHandlerProvider(WaveTransHandlerProvider);
}
//---------------------------------------------------------------------------
void UnregisterWaveTransHandlerProvider()
{
	// TVPRemoveTransHandlerProvider găgWVnhvoC_
	// o^
	TVPRemoveTransHandlerProvider(WaveTransHandlerProvider);
	WaveTransHandlerProvider->Release();
}
//---------------------------------------------------------------------------
